\documentstyle[12pt,amstex,amssymb]{article}
\def\ga{\alpha}
\def\gb{\beta}
\def\gc{\gamma}
\def\gd{\delta}
\def\ge{\epsilon}
\def\gz{\zeta}
\def\gy{\eta}
\def\th{\theta}
\def\gi{\iota}
\def\gk{\kappa}
\def\gl{\lambda}
\def\gm{\mu}
\def\gn{\nu}
\def\gx{\xi}
\def\gp{\pi}
\def\gr{\rho}
\def\gs{\sigma}
\def\gt{\tau}
\def\gu{\upsilon}
\def\ph{\phi}
\def\ch{\chi}
\def\ps{\psi}
\def\gw{\omega}

\def\gB{\Beta}
\def\gC{\Gamma}
\def\gD{\Delta}
\def\Th{\Theta}
\def\gL{\Lambda}
\def\gX{\Xi}
\def\gP{\Pi}
\def\gS{\Sigma}
\def\gU{\Upsilon}
\def\Ph{\Phi}
\def\Ps{\Psi}
\def\gW{\Omega}

\def\bA{{\bf A}}
\def\bB{{\bf B}}
\def\bC{{\bf C}}
\def\bD{{\bf D}}
\def\bE{{\bf E}}
\def\bF{{\bf F}}
\def\bG{{\bf G}}
\def\bH{{\bf H}}
\def\bI{{\bf I}}
\def\bJ{{\bf J}}
\def\bK{{\bf K}}
\def\bL{{\bf L}}
\def\bM{{\bf M}}
\def\bN{{\bf N}}
\def\bO{{\bf O}}
\def\bP{{\bf P}}
\def\bQ{{\bf Q}}
\def\bR{{\bf R}}
\def\bS{{\bf S}}
\def\bT{{\bf T}}
\def\bU{{\bf U}}
\def\bV{{\bf V}}
\def\bW{{\bf W}}
\def\bX{{\bf X}}
\def\bY{{\bf Y}}
\def\bZ{{\bf Z}}

\def\cA{{\cal A}}
\def\cB{{\cal B}}
\def\cC{{\cal C}}
\def\cD{{\cal D}}
\def\cE{{\cal E}}
\def\cF{{\cal F}}
\def\cG{{\cal G}}
\def\cH{{\cal H}}
\def\cI{{\cal I}}
\def\cJ{{\cal J}}
\def\cK{{\cal K}}
\def\cL{{\cal L}}
\def\cM{{\cal M}}
\def\cN{{\cal N}}
\def\cO{{\cal O}}
\def\cP{{\cal P}}
\def\cQ{{\cal Q}}
\def\cR{{\cal R}}
\def\cS{{\cal S}}
\def\cT{{\cal T}}
\def\cU{{\cal U}}
\def\cV{{\cal V}}
\def\cW{{\cal W}}
\def\cX{{\cal X}}
\def\cY{{\cal Y}}
\def\cZ{{\cal Z}}


\def\ba{{\bf a}}
\def\bb{{\bf b}}
\def\bc{{\bf c}}
\def\bd{{\bf d}}
\def\be{{\bf e}}
\def\bg{{\bf g}}
\def\bh{{\bf h}}
\def\bi{{\bf i}}
\def\bj{{\bf j}}
\def\bk{{\bf k}}
\def\bl{{\bf l}}
\def\bm{{\bf m}}
\def\bn{{\bf n}}
\def\bo{{\bf o}}
\def\bp{{\bf p}}
\def\bq{{\bf q}}
\def\br{{\bf r}}
\def\bs{{\bf s}}
\def\bt{{\bf t}}
\def\bu{{\bf u}}
\def\bv{{\bf v}}
\def\bw{{\bf w}}
\def\bx{{\bf x}}
\def\by{{\bf y}}
\def\bz{{\bf z}}

\def\b0{{\bf0}}
\def\o{\circ}
\def\x{\times}
\def\d{\partial}
\def\<{\langle}
\def\>{\rangle}
\def\R{{\mathbb R}}
\def\Z{{\mathbb Z}}
\def\Q{{\mathbb Q}}
\def\N{{\mathbb N}}
\def\C{{\mathbb C}}
\def\T{{\mathbb T}}
\def\Cinf{C^\infty}
\def\sb{\subseteq}
\def\sp{\superseteq}
\def\({\left(}
\def\){\right)}
\def\rank{\mbox{rank}\,}
\def\rk{\mbox{rank}\,}
\def\ddt{\frac d{dt}}
\def\corank{\mbox{corank}\,}
\def\cl{\hbox{cl}\,}
\def\im{\hbox{im}\,}
\def\Id{\hbox{Id}}
\def\Diff{\hbox{Diff}}
\def\tv{\pitchfork}
\def\ntv{\not\tv}
\def\codim{\hbox{codim}\,}
\def\tr{\hbox{tr}\,}
\def\cosec{\hbox{cosec}\,}
\def\const{\hbox{const}}
\def\lc{\lceil}
\def\rc{\rceil}
\def\lf{\lfloor}
\def\rf{\rfloor}
\def\sech{\hbox{sech}\,}
\def\csch{\hbox{csch}\,}
\def\grad{\hbox{grad}\,}
\def\nbhd{neighbourhood}
\def\dlim{\displaystyle\lim}
\def\dfrac#1#2{\displaystyle{#1\over#2}}
\def\dsum{\displaystyle\sum}
\def\dint{\displaystyle\int}
\def\diint{\displaystyle\iint}
\def\diiint{\displaystyle\iiint}
\def\doint{\displaystyle\oint}
\def\tlim{\textstyle\lim}
\def\tfrac#1#2{\textstyle{#1\over#2}}
\def\tsum{\textstyle\sum}
\def\tint{\textstyle\int}
\def\del{\nabla}
\def\div{\hbox{div}\,}
\def\curl{\hbox{curl}\,}
\def\intL{\int\limits}
\def\iintL{\iint\limits}
\def\iiintL{\iiint\limits}

\def\abs{\hbox{abs}\,}
\def\sgn{\hbox{sgn}\,}
\def\dom{\hbox{dom}\,}


\def\eval{\,\Bigl.\Bigl|}



\def\drawbox#1{\lower6pt\hbox{{\vbox{\hrule\hbox{\vrule\kern15pt
   \vbox{\kern10pt\vbox{\hbox{#1}}\kern10pt} 
   \kern18pt\vrule}\hrule}}}}

\def\picture #1 by #2 (#3){
  \medbreak
		$$\vbox to #2{
    \hrule width #1 height 0pt depth 0pt
    \vfill
    \special{picture #3}
  }$$
}

\def\scaledpicture #1 by #2 (#3 scaled #4){
  \dimen0=#1 
		\dimen1=#2
  \divide\dimen0 by 1000 
   \multiply\dimen0 by #4
  \divide\dimen1 by 1000 
   \multiply\dimen1 by #4
  \picture \dimen0 by \dimen1 (#3 scaled #4)}
%\input mypars
%The following are plain tex style parameters 

\baselineskip=12pt
\hoffset=0pt
\voffset=0 cm
\leftskip=0pt
\rightskip=0pt
\parindent=0cm

%And these are latex style parameters

\headsep=0cm
\headheight=0cm
\evensidemargin=0cm
\oddsidemargin=0cm
\parskip=12pt
\textwidth=16.5 true cm
\textheight=22 true cm
\topmargin=1cm

\def\Gr{Gr\"obner}
\def\kn{k[x_1,\dots,x_n]}
\def\lc{{\sc LC}}
\def\lt{{\sc LT}}
\def\gcd{{\sc GCD}}

\newtheorem{theorem}{Theorem}
\newtheorem{lemma}{Lemma}[section]
\newtheorem{definition}{Definition}[section]
\newtheorem{example}{Example}[section]
\newtheorem{corollary}[theorem]{Corollary}


\newenvironment{proof}
{\begin{trivlist}
\item[\hskip \labelsep {\bf Proof.}]
}
{\hfill$\Box$
\end{trivlist}}
           

\def\pagenumbers{\headline={\iftitle\hfil\global\titlefalse                     
   \else\hss\rm\folio\hss\fi}}                                                  
\newtoks\option                                                                 
\newtoks\solnhead                                                               
\newtoks\sheetname                                                              
\option={,}                                                                     
\def\separate#1,#2@{\def\optionid{#1}\def\optionname{#2}}                      
\def\fullwidth{\everypar{}\parindent=0pt\relax}                                 

\def\maketitle{
\begin{center}
{\sc Victoria University of Wellington\\
School of Mathematics, Statistics and Operations Research}\\
\smallskip
{\sl
Te Kura M{\=a}tai Tatauranga, Rangahau P{\=u}naha}
\end{center}
\expandafter\separate\the\option@
\hbox to\hsize{\hrulefill}
\nointerlineskip
\vskip3pt                                  
\hbox
to\hsize{\strut\rlap{\optionid}\hfill{\sc\optionname}\hfill\llap{\number\year}}          
\nointerlineskip
\vskip2pt
\hbox to\hsize{\hrulefill}}

\let\filbreak=\relax                                                           
\def\head{\filbreak\vskip 18pt\fullwidth                                    
   \def\filbreak{\global\let\filbreak=\fillbreak}%                            
   \centerline{\large\bf \the\sheetname}\nobreak
   \vskip 12pt minus 3pt}                                                       
\def\tutorial{\sheetname={Tutorial}\head}                                      
\def\assignment{\sheetname={Assignment}\head}                                  
\def\sheet#1{\sheetname={#1}\head}                                             
\def\showdue#1{\hbox to\hsize{\hfil Due: #1}
\vskip 5pt minus 3pt}

\leftmargin=0pt              

\begin{document}

\option={MATH 437,Gr\"obner Bases and Their Applications}        
\maketitle
\medskip 
\setcounter{section}3
\section{The Division Algorithm}


Let's concentrate on polynomials in one variable and recall the process of division.

\begin{example} 
Find the quotient and remainder in $\Q[x]$ when dividing
$f=x^3-2x^2+2x+8$ by $g=2x^2+3x+1$.\\[-5ex]
\end{example}

\[
\begin{array}{cl}
&\frac12x-\frac74\\
&\hrulefill\\
2x^2+3x+1&\multicolumn{1}{|l}{x^3-2x^2+2x+8}\\
&x^3+\frac32x^2+\frac12x\\
&\hrulefill\\
&\kern0.7cm -\frac72x^2+\frac32x+8\\[1ex]
&\kern0.7cm -\frac72x^2-\frac{21}4x-\frac74\\
&\hrulefill\\
&\kern2cm \frac{27}4x+\frac{39}4
\end{array}
\]

This tells us that
\[
f=(\tfrac12x-\tfrac74)g+(\tfrac{27}4x+\tfrac{39}4).
\]
This is, in effect, an algorithm, which we'll now try to describe in a more
algorithmic fashion.  We can write
\[
f\stackrel{g}{\longrightarrow}_+r.
\]
The $+$ subscript indicates we have gone as far as we can go with this process.

The end goal is to generalise this algorithm to sets of
multivariable polynomials. We will use the linear case as a guide.

First some notation.  Given $f\in k[x]$, $f\neq0$, recall that the {\bf degree} of
$f$ is the largest power of $x$ that appears in $f$. The {\bf leading term},
$\lt(f)$ is that term of $f$ of highest degree and the {\bf leading coefficient}
$LC(f)$ is the coefficient of $\lt(f)$.

\begin{theorem}[Division Algorithm]
Given $g\in k[x]$, $g\neq0$ and $f\in k[x]$, there exist $q,r\in k[x]$ such that
$f=qg+r$ with $\deg(r)<\deg(g)$ or $r=0$. Moreover $q$ and $r$ are unique.
\end{theorem}

\begin{proof}
We present an algorithm:
\begin{itemize}
\item
{\bf INITIAL VALUES:} $r:=f$, $q:=0$.
\item
{\bf ALGORITHM: While $r\neq0$ and $\deg r\geq\deg g$}
\begin{eqnarray*}
q&:=&q+\frac{\lt(r)}{\lt(g)}\\
r&:=&r-\frac{\lt(r)}{\lt(g)}g
\end{eqnarray*}
\end{itemize}

Note that at each stage of this process, the equation $f=qg+r$ holds and that the degree of $r$ strictly decreases. This
ensures that the process is finite and halts when $\deg r<\deg g$.  
Uniqueness of $q,r$ is left as an exercise.
\end{proof}

Recall that we proved that a non-zero polynomial $f$ over an infinite field could
not vanish identically as a function $\hat f$. We used the following which holds
for an arbitrary field $k$. 

\begin{corollary}
If $f\in k[x]$ ($f\neq0$) has degree~m, then $f$ has at most $m$ roots.
\end{corollary}

\begin{proof}
By induction on $m$. If $m=0$ then $f$ is a non-zero constant so has no roots. Now
suppose the result is true for degree $m-1$ and let $f$ have degree $m$. Either $f$
has no roots or, there is a root $x=a$, say.  By the Division Algorithm we may write
\[
f=q(x-a)+r
\]
where $\deg r<\deg(x-a)=1$, so $r$ is a constant. Now $0=f(a)=q(a)(a-a)+r=r$ so
$f=q(x-a)$. Moreover, $\deg f=\deg q+1$ so $\deg q=m-1$. Suppose $b\neq a$ is also
a root of $f$ then $0=f(b)=q(b)(b-a)$ so $q(b)=f(b)/(b-a)=0$  and $b$ is a root of
$q$. But $q$ has at most $m-1$ roots by inductive hypothesis, hence $f$ has at most
$(m-1)+1=m$ roots.
\end{proof}


Another important deduction from the Division Algorithm, which says in algebraic
language, that every ideal is {\it principal} and so $k[x]$ is a {principal ideal
domain}, is:

\begin{theorem}
Every ideal in $k[x]$ is generated by a single element.
\end{theorem}

\begin{proof}
Let $I\subseteq k[x]$ be a non-trivial ideal. Choose $g\in I$ such that $n=\deg
g\leq\deg f$ for all $f\in I$. Now for any $f\in I$, $f=qg+r$ as in the Division
Algorithm.  But if $r\neq0$ then $r=f-qg\in I$ and $\deg r<\deg g$, contradicting
the choice of $g$. Hence $r=0$ and $f=qg\Rightarrow f\in\<g\>$. Hence
$I\subseteq\<g\>$, while $g\in I$ gives $I=\<g\>$ as required.
\end{proof}

Given an ideal $I=\<f_1,\dots,f_s\>$, how are we to arrive at this unique (up to
constant multiple) generator?   Define the {\bf greatest common divisor}
$\gcd(f_1,f_2)$ of two polynomials $f_1,f_2\in k[x]$ to be a polynomial $g$ such that
\begin{itemize}
\item
$g$ divides $f_1$ and $f_2$
\item
if $h$ divides $f_1,f_2$ then $h$ divides $g$
\item
$\lc(g)=1$ ($g$ is {\it monic\/}).
\end{itemize}

\begin{theorem}
If $f_1,f_2\in k[x]$ are not both zero then $\gcd(f_1,f_2)$ exists and
$\<f_1,f_2\>=\<\gcd(f_1,f_2)\>$.
\end{theorem}

The proof is an exercise.  What we need is an algorithm for finding \gcd s. This is
the well known {\it Euclidean algorithm\/}.
Given $f_1,f_2\in k[x]$,
\begin{itemize}
\item
{\bf INITIAL VALUES:} $f:=f_1$, $g:=f_2$.
\item
{\bf ALGORITHM: While $g\neq0$ }
\begin{eqnarray*}
&f&\stackrel{g}{\longrightarrow_+}r\\
&f&:=g\\
&g&:=r
\end{eqnarray*}
\item
$f:=\frac1{\lc(f)}f$
\end{itemize}

The success of the algorithm depends on the fact that for any $q\in k[x]$,
${\gcd}(f_1-qf_2,f_2)=\gcd(f_1,f_2)$. The details are an exercise.

\begin{example} 
Find the {\gcd} of $f_1=x^3-3x+2$ and $f_2=x^2-1$ in $\Q[x]$.\\[-5ex]
\end{example}

For more general ideals, we can simply extend the definition of {\gcd} to several
polynomials and then use the following:

\begin{lemma}
Given $f_1,\dots,f_s\in k[x]$,
\begin{enumerate}
\item
$\<f_1,\dots,f_s\>=\<\gcd(f_1,\dots,f_s)\>$.
\item
if $s\geq3$ then $\gcd(f_1,\dots,f_s)=\gcd(f_1,\gcd(f_2,\dots,f_s))$
\end{enumerate}
\end{lemma}

\end{document}


